#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

typedef vector<int> vi;

struct info {
    info(int pos = 0, int d = 0, long long best = 0) : pos(pos), d(d), best(best) {}
    int pos, d;
    long long best;
};

int gcd(int a, int b) {
    if (!b) return a; return gcd(b, a % b);
}

vector<long long> S;
void set_val(int pos, long long val) {
    while (pos > 0) {
        S[pos] = max(S[pos], val);
        pos &= pos - 1;
    }
}

long long get_max(int l, int r) {
    if (l > r)
        return -(1LL << 60);
    if (r == 0) return 0;
    if (l == 0) l = 1;
    long long res = S[l];
    while (l < S.size()) {
        res = max(res, S[l]);
        l = l * 2 - (l & (l - 1));
    }
    return res;
}

long long solve(vi a, int d) {
    a.insert(a.begin(), 0);

    if (d == 1) {
        long long res = 0;
        for (int i = 0; i < a.size(); ++i)
            res += a[i];
        return res;
    }

    vector<info> borders(1, info(0, 0, 0));
    vector<long long> ans(a.size(), -(1LL << 60)); ans[0] = 0;
    S.assign(a.size(), -(1LL << 60));

    for (int i = 1; i < a.size(); ++i) {
        for (int j = 1; j < borders.size(); ++j)
            borders[j].d = gcd(borders[j].d, a[i]);
        int k = 0;
        for (int j = 1; j < borders.size(); ++j) {
            if (borders[k].d == borders[j].d) {
                borders[k].best = max(borders[k].best, borders[j].best);
            } else {
                borders[++k] = borders[j];
            }
        }
        borders.resize(k + 1);

        if (i >= d) {
            set_val(i - d, ans[i - d]);
            for (int j = 0; j < borders.size(); ++j) {
                if (j + 1 < borders.size() && i - d + 1 >= borders[j + 1].pos) {
                    if (borders[j + 1].pos - borders[j].pos > 1)
                        ans[i] = max(ans[i], borders[j].best + borders[j].d);
                    ans[i] = max(ans[i], ans[borders[j + 1].pos - 1] + borders[j + 1].d);
                } else {
                    long long mx = get_max(borders[j].pos, i - d);
                    ans[i] = max(ans[i], mx + borders[j].d);
                    break;
                }
            }
        } else {
            // nothing
        }

        borders.push_back(info(i, a[i], ans[i]));
    }

    return ans.back();
}

int main()
{
    ifstream sis("gcdsis.txt");
    ofstream val("gcdval.txt");

    int n, m, d; sis >> n >> m >> d;
    vi a;
    for (int i = 0; i < n; ++i) {
        int k; sis >> k;
        for (int j = 0; j < k; ++j) {
            int x; sis >> x; a.push_back(x);
        }
    }
    val << solve(a, d) << endl;

    return 0;
}
