#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

typedef vector<int> vi;

int solve(vi a) {
    const size_t _n = a.size();

    vi b = a; sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    for (int i = 0; i < a.size(); ++i) a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();

    int k = 0;
    for (int i = 1; i < a.size(); ++i) if (a[i] != a[k]) {
        a[++k] = a[i];
    }
    a.resize(k+1);

    vector<vi> pos(b.size());
    for (int i = 0; i < a.size(); ++i) {
        pos[a[i]].push_back(i);
    }

    vector<int> res(a.size());
    for (int i = 0; i < pos.size(); ++i) {
        int p1, m1;
        int p2, m2;
        int m;
        p1 = p2 = a.size();
        m = 0;
        m1 = m2 = a.size();

        if (i) {
            m = m1 = m2 = a.size();
            for (int j = 0; j < pos[i - 1].size(); ++j) {
                int p = pos[i-1][j];
                m = min(m, res[p]);

                if (p + 1 < a.size() && a[p] + 1 == a[p + 1]) {
                    if (m1 > res[p]) {
                        m2 = m1; p2 = p1;
                        p1 = p; m1 = res[p];
                    } else if (m2 > res[p]) {
                        m2 = res[p]; p2 = p;
                    }
                }
            }
        }

        if (pos[i].size() == 1) {
            int p = pos[i][0];
            res[p] = min(m + 1, m1);
        } else {
            for (int j = 0; j < pos[i].size(); ++j) {
                int p = pos[i][j];
                res[p] = m + pos[i].size();
                if (p1 + 1 != p)
                    res[p] = min(res[p], (int)(m1 + pos[i].size() - 1));
                if (p2 + 1 != p)
                    res[p] = min(res[p], (int)(m2 + pos[i].size() - 1));
            }
        }
    }

    int result = a.size();
    for (int i = 0; i < pos.back().size(); ++i)
        result = min(result, res[pos.back()[i]]);
    return result;
}

int main()
{
    ifstream sis("sortsis.txt");
    ofstream val("sortval.txt");

    int n; sis >> n;
    vi a(n); for (size_t i = 0; i < n; ++i) sis >> a[i];
    val << solve(a) << '\n';

    return 0;
}
